Subject: Re: [Patch iproute2] u32: add terminal parameter

From: Jamal Hadi Salim <[email-masked]>
Date: Tue, 15 Apr 2014 09:00:18 -0400

On 04/14/14 21:57, Cong Wang wrote:

> So essentially why u32 filters can't just do matching without bothering

u32 is a special animal. You can actually have intermediate nodes
which are _not_ terminal. i.e you can build a tree of hashes which
interconnect other hashes eventually leading to terminal nodes.

> classid especially when they are attached to an ingress qdisc? I still
> fail to see a reason why I have to care about classid here.

It is more of a historical artifact with "benefits".
Historical in that egress qdiscs with classes existed before ingress;
so it makes sense to keep the syntax people are already familiar with.
Benefits because infact with the right approach the flowid even at
ingress can be used as input(look at the route classifier for example
and association with route accounting of the source).

cheers,
jamal